<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>blog.winny.tech</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">
<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<h1 class="title">Posts tagged "productivity":</h1>
<div class="post-date">01 Nov 2019</div><h1 class="post-title"><a href="2019-11-01-track-down-basic-emacs-bugs-hangs.html">Track down basic Emacs bugs & hangs</a></h1>
<p>
I ran into a hang today with only ivy enabled and nothing else
configured or installed. The behavior was such that after I typed a
hostname with a TLD (such as <code>not.existant.com</code><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup>), then typed
<code>C-x d</code> to visit a directory or <code>C-x C-f</code> to find a file, Emacs would
hang. My mouse would turn into a pin-wheel. My only recourse was to
send the 'quit' command via <code>C-g</code> to cancel the
operation. Unfortunately this meant I could not do one of the simplest
operations in Emacs - visiting files and directories.
</p>

<div id="outline-container-org6a39465" class="outline-2">
<h2 id="org6a39465">Enter <code>debug-on-quit</code></h2>
<div class="outline-text-2" id="text-org6a39465">
<p>
After some searching <a href="https://www.gnu.org/software/emacs/manual/html_node/eintr/Debugging.html#Debugging">I found</a> the <code>debug-on-quit</code> and <code>debug-on-error</code>
variables<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>, with their corresponding commands <code>toggle-debug-on-quit</code>
and <code>toggle-debug-on-error</code>. Enabling <code>debug-on-quit</code> means I can get
a backtrace when I type <code>C-g</code> of what was happening before I signaled
Emacs to quit the current command. Here is an example backtrace:
</p>

<div class="org-src-container">
<pre class="src src-fundamental">Debugger entered--Lisp error: (quit)
  make-network-process(:name <span style="color: #61CE3C;">"ffap-machine-p"</span> :buffer nil :host <span style="color: #61CE3C;">"not.existant.com"</span> :service <span style="color: #61CE3C;">"discard"</span> :nowait nil :tls-parameters nil)
  open-network-stream(<span style="color: #61CE3C;">"ffap-machine-p"</span> nil <span style="color: #61CE3C;">"not.existant.com"</span> <span style="color: #61CE3C;">"discard"</span>)
  ffap-machine-p(<span style="color: #61CE3C;">"not.existant.com"</span>)
  ffap-machine-at-point()
  ffap-guesser()
  ffap-guess-file-name-at-point()
  run-hook-with-args-until-success(ffap-guess-file-name-at-point)
  ivy-thing-at-point()
  ivy--reset-state(#s(ivy-state :prompt <span style="color: #61CE3C;">"Find file: "</span> :collection read-file-name-internal :predicate nil :require-match confirm-after-completion :initial-input nil :history file-name-history :preselect nil :keymap (keymap (96 lambda (&amp;optional arg) <span style="color: #61CE3C;">"nil (`nil')"</span> (interactive <span style="color: #61CE3C;">"p"</span>) (if (string= <span style="color: #61CE3C;">""</span> ivy-text) (execute-kbd-macro (kbd <span style="color: #61CE3C;">"M-o b"</span>)) (self-insert-command arg))) (C-backspace . counsel-up-directory) (67108991 . counsel-up-directory)) :update-fn nil :sort nil :frame #&lt;frame (Emacs) dummy.txt [Text] /tmp/dummy.txt 0x70a1e20&gt; :window #&lt;window 7 on dummy.txt&gt; :buffer #&lt;buffer dummy.txt&gt; :text nil :action (1 (<span style="color: #61CE3C;">"o"</span> counsel-find-file-action <span style="color: #61CE3C;">"default"</span>) (<span style="color: #61CE3C;">"i"</span> #f(compiled-function (x) #&lt;bytecode 0x1b79a11&gt;) <span style="color: #61CE3C;">"insert"</span>) (<span style="color: #61CE3C;">"w"</span> #f(compiled-function (x) #&lt;bytecode 0x1b79a21&gt;) <span style="color: #61CE3C;">"copy"</span>) (<span style="color: #61CE3C;">"j"</span> find-file-other-window <span style="color: #61CE3C;">"other window"</span>) (<span style="color: #61CE3C;">"f"</span> find-file-other-frame <span style="color: #61CE3C;">"other frame"</span>) (<span style="color: #61CE3C;">"b"</span> counsel-find-file-cd-bookmark-action <span style="color: #61CE3C;">"cd bookmark"</span>) (<span style="color: #61CE3C;">"x"</span> counsel-find-file-extern <span style="color: #61CE3C;">"open externally"</span>) (<span style="color: #61CE3C;">"r"</span> counsel-find-file-as-root <span style="color: #61CE3C;">"open as root"</span>) (<span style="color: #61CE3C;">"R"</span> find-file-read-only <span style="color: #61CE3C;">"read only"</span>) (<span style="color: #61CE3C;">"k"</span> counsel-find-file-delete <span style="color: #61CE3C;">"delete"</span>) (<span style="color: #61CE3C;">"c"</span> counsel-find-file-copy <span style="color: #61CE3C;">"copy file"</span>) (<span style="color: #61CE3C;">"m"</span> counsel-find-file-move <span style="color: #61CE3C;">"move or rename"</span>) (<span style="color: #61CE3C;">"d"</span> counsel-find-file-mkdir-action <span style="color: #61CE3C;">"mkdir"</span>)) :unwind nil :re-builder nil :matcher counsel--find-file-matcher :dynamic-collection nil :display-transformer-fn ivy-read-file-transformer :directory <span style="color: #61CE3C;">"/tmp/"</span> :caller counsel-find-file :current nil :def nil :ignore t :multi-action nil :extra-props nil))
  ivy-read(<span style="color: #61CE3C;">"Find file: "</span> read-file-name-internal :matcher counsel--find-file-matcher :initial-input nil :action counsel-find-file-action :preselect nil :require-match confirm-after-completion :history file-name-history :keymap (keymap (96 lambda (&amp;optional arg) <span style="color: #61CE3C;">"nil (`nil')"</span> (interactive <span style="color: #61CE3C;">"p"</span>) (if (string= <span style="color: #61CE3C;">""</span> ivy-text) (execute-kbd-macro (kbd <span style="color: #61CE3C;">"M-o b"</span>)) (self-insert-command arg))) (C-backspace . counsel-up-directory) (67108991 . counsel-up-directory)) :caller counsel-find-file)
  counsel--find-file-1(<span style="color: #61CE3C;">"Find file: "</span> nil counsel-find-file-action counsel-find-file)
  counsel-find-file()
  funcall-interactively(counsel-find-file)
  call-interactively(counsel-find-file nil nil)
  command-execute(counsel-find-file)
</pre>
</div>

<p>
If one tries this, they'll also notice every function is a link to the
corresponding Emacs lisp or C source function. Pressing <code>RET</code> with
point on an item will find its definition. Use <code>C-.</code> and <code>C-,</code> as
usual to <a href="https://www.gnu.org/software/emacs/manual/html_node/emacs/Looking-Up-Identifiers.html#Looking-Up-Identifiers">follow and return from function definitions</a>.
</p>

<p>
Thanks to this feature, I was able to quickly focus on a "bug" related
to the find file at point subsystem as used by ivy, which causes Emacs
to ping random hostname-looking addresses under the point. <a href="https://github.com/abo-abo/swiper/issues/2311">I reported
it</a>, maybe a default will get changed; most importantly, it's
documented somewhere now.
</p>
</div>
</div>

<div id="outline-container-orgf3dd6ee" class="outline-2">
<h2 id="orgf3dd6ee">Don't forget about <code>debug-on-error</code></h2>
<div class="outline-text-2" id="text-orgf3dd6ee">
<p>
<code>debug-on-error</code> is also extremely useful, especially when extending
Emacs with your own Elisp code. When I write Elisp, I almost always
enabled this when testing. The Elisp language and its libraries are
somewhat anachronistic and each component is seemingly tightly coupled
with the next, making it hard to understand any particular
subsystem. You <span class="underline">will</span> write bad Elisp, even if you're a wizard.
Everybody writes buggy Elisp. That's why I find an Emacs bug
every few months.  <a href="https://www.emacswiki.org/emacs/WhyDoesElispSuck">It's just a very awkward language</a>. Regardless, Emacs
is probably the most flexible and powerful editor out there, and in
this case, <a href="https://www.dreamsongs.com/WorseIsBetter.html">Worse is Better</a>. And don't forget, a good challenge is a
fun challenge.
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
I know I misspelled existent. What's important is it's
recognized as a valid fully qualified domain name by Emacs.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
By the way, you can just read the info pages in Emacs (<code>C-h
i</code>). Don't be like me, and read the infopages in the web browser,
that's silly. Emacs is the best documetation browser. :)
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-emacs.html">emacs</a> <a href="tag-productivity.html">productivity</a> </div>
<div class="post-date">28 Jul 2019</div><h1 class="post-title"><a href="2019-07-28-open-url-in-existing-qutebrowser-from-emacs-daemon-on-gentoo.html">Open URL in existing Qutebrowser from Emacs Daemon on Gentoo</a></h1>
<p>
On my Gentoo desktops, I use Emacs Daemon via <code>sys-emacs/emacs-daemon</code><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup>
to ensure an Emacs instance is ready to go and always available from
boot. This is done via creating a symbolic link like
<code>/etc/init.d/emacs.winston</code> to <code>/etc/init.d/emacs</code> which will start Emacs
for the given user. See the package README for more details.
</p>

<p>
A shortcoming of this setup is <code>XDG_RUNTIME_DIR</code><sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup> is not set, as this is
set by my Desktop Session - maybe LightDM or consolekit set this? As a
result, when I open a URL from Emacs Daemon, it opens a fresh
qutebrowser session, loading the saved default session, and making a
mess of my workflow.
</p>

<p>
One approach to fix this might be to instead run Emacs daemon from my
<code>.xsession</code> script, but I rather not supervise daemons at the user
level; if I were to consider this, I'd be better off to switch to
systemd for user-level services anyway.
</p>

<p>
The solution I came up with is to add some lines to my <code>init.el</code> to
ensure <code>XDG_RUNTIME_DIR</code> is set to the expected value:
</p>

<div class="org-src-container">
<pre class="src src-emacs-lisp">(<span style="color: #4c83ff;">defun</span> <span style="color: #ff1493;">winny/ensure-XDG_RUNTIME_DIR</span> ()
  <span style="color: #FBDE2D;">"Ensure XDG_RUNTIME_DIR is set. Used by qutebrowser and other utilities."</span>
  (<span style="color: #4c83ff;">let</span> ((rd (getenv <span style="color: #61CE3C;">"XDG_RUNTIME_DIR"</span>)))
    (<span style="color: #4c83ff;">when</span> (<span style="color: #4c83ff;">or</span> (not rd) (string-empty-p rd))
      (setenv <span style="color: #61CE3C;">"XDG_RUNTIME_DIR"</span> (format <span style="color: #61CE3C;">"/run/user/%d"</span> (user-uid))))))

(add-hook 'after-init-hook #'winny/ensure-XDG_RUNTIME_DIR)
</pre>
</div>

<p>
A strange emacs-ism: <code>(user-uid)</code> returns float or integer, despite the
backing <code>uid_t</code> (on *nix) is guarenteed to be an integer type. I'll just
assume this'll never return a float. Please contact me otherwise, I'd
love to hear about this.
</p>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
<a href="https://packages.gentoo.org/packages/app-emacs/emacs-daemon">https://packages.gentoo.org/packages/app-emacs/emacs-daemon</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
<a href="https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html">freedesktop.org XDG Base Directory Specification</a>
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-emacs.html">emacs</a> <a href="tag-productivity.html">productivity</a> <a href="tag-computing.html">computing</a> <a href="tag-gentoo.html">gentoo</a> <a href="tag-qutebrowser.html">qutebrowser</a> </div>
<div class="post-date">09 Jan 2019</div><h1 class="post-title"><a href="2019-01-09-toggle-redshift-with-keyboard-shortcut.html">Toggle Redshift with Keyboard Shortcut</a></h1>
<p>
Redshift is a screen-tinting program that achieves similar goals to
the popular f.lux<sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> program.
</p>

<p>
I perused through the redshift man-pages and noticed there is no
documented way to toggle redshift. Of course one can click the
notification area icon when using redshift-gtk or <code>SIGTERM</code> the
redshift process, but neither is very user friendly. (The mouse is not
user friendly.) After some awkward DuckDuckGo-ing and Googling I found
an obvious solution on the redshift homepage<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>: simply send <code>SIGUSR1</code> to
the redshift or redshift-gtk process. When using redshift-gtk, one can
choose to send <code>SIGUSR1</code> to either redshift or redshift-gtk.
</p>

<p>
This is the script I came up with:
</p>

<div class="org-src-container">
<pre class="src src-sh"><span style="color: #8B8989; font-style: italic;">#</span><span style="color: #8B8989; font-style: italic;">!/bin/</span><span style="color: #4c83ff;">sh</span>
<span style="color: #4c83ff;">set</span> -eu
<span style="color: #4c83ff;">if</span> ! pkill -x -SIGUSR1 redshift; <span style="color: #4c83ff;">then</span>
    <span style="color: #4c83ff;">echo</span> <span style="color: #61CE3C;">'Could not find redshift process to toggle.'</span> &gt;&amp;2
    <span style="color: #4c83ff;">exit</span> 1
<span style="color: #4c83ff;">fi</span>
</pre>
</div>

<p>
After installing the script into my system's <code>PATH</code>, now all I have to
do is add a line to my Xbindkeys<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup> configuration file (<code>~/.xbindkeysrc.scm</code>) such as:
</p>

<div class="org-src-container">
<pre class="src src-scheme">(xbindkey '(Mod4 F2) <span style="color: #61CE3C;">"toggle-redshift"</span>)
</pre>
</div>

<p>
Now I can type <code>Mod4-F2</code> and toggle Redshift.
</p>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
<a href="https://justgetflux.com/">f.lux homepage</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
<a href="http://jonls.dk/redshift/#configuration-options">Redshift homepage § Configuration Options</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
<a href="http://www.nongnu.org/xbindkeys/xbindkeys.html">XBindKeys homepage</a>
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-productivity.html">productivity</a> <a href="tag-computing.html">computing</a> </div><div id="archive">
<a href="archive.html">Other posts</a>
</div>
</div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
